/*
 * This file is a part of Netacka 3D.
 *
 * Copyright 2010
 * Leszek Bartkowski, Mikołaj Dądela, Paweł Marczewski, Jan Szejko
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package netacka3d.data;

/**
 * Klasa opisująca czas fizyczny.
 * 
 * @author humpolec
 */
public final class RoundTime {
    /** numer kroku */
    public int t;
    /** część ułamkowa - w zakresie [0..1] */
    public float tFrac;
    
    /** do deserializacji */
    public RoundTime()
    {}
    
    public RoundTime(int t, float tFrac) {
        this.t = t;
        this.tFrac = tFrac;
    }
    
    /** Czy ta chwila jest później niż podana */
    public boolean isAfter(RoundTime rT) {
        return t > rT.t || (t == rT.t && tFrac > rT.tFrac);
    }
}
