/*
 * This file is a part of Netacka 3D.
 *
 * Copyright 2010
 * Leszek Bartkowski, Mikołaj Dądela, Paweł Marczewski, Jan Szejko
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package netacka3d.misc;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;

/**
 * Tutaj siedzą wszystkie funkcje operujące na plikach - zamykamy je w takiej 
 * klasie, żeby być platform-independent. 
 * @author mik01aj
 */
public class FileIOBackend {

    /**
     * Otwiera plik o podanej nazwie, z folderu danych gry.
     * 
     * UWAGA: Ta implementacja powinna być używana tylko do testów!
     * (bo odwołujemy się do innej ścieżki niż normalnie)
     * 
     * @param filename
     * @throws FileNotFoundException
     */
    public InputStream openFile(String filename) 
                throws FileNotFoundException {
        File file = new File("test/data/test", filename);
        Logger.i("Opening " + file.getAbsolutePath());
        return new FileInputStream(file);
    }
    
    /** 
     * Załaduj obrazek jako bufor bajtów RGBA.
     */
    public ByteBuffer loadImage(String filename, int[] dims) 
                throws IOException {
        throw new RuntimeException("Not implemented");
    }
    
}
