/*
 * This file is a part of Netacka 3D.
 *
 * Copyright 2010
 * Leszek Bartkowski, Mikołaj Dądela, Paweł Marczewski, Jan Szejko
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package netacka3d;


import java.util.Arrays;

import javax.vecmath.Point3f;

import netacka3d.data.arena.Mesh;
import netacka3d.data.arena.MeshData;
import netacka3d.misc.Logger;
import netacka3d.misc.NumberParser;

import org.junit.Test;
import static org.junit.Assert.*;


public class MeshTest {

    @Test
    public void bla() {
        Mesh m = new Mesh();
        m.addPoint(new Point3f(0, 0, 0));
        m.addPoint(new Point3f(0, 0, 1));
        m.addPoint(new Point3f(0, 1, 0));
        Mesh.FaceBuilder fB = m.new FaceBuilder();
        fB.addVertex(1, 0, 0);
        fB.addVertex(2, 0, 0);
        fB.addVertex(3, 0, 0);
        fB.commit();
        MeshData mD = m.getData();
        float[] expectedVs = {0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 1.0f, 0.0f};
        assertArrayEquals(expectedVs, mD.bufs[0].vs, 0.000001f);
    }
    
}
