# -*- coding: utf-8 -*-

# This file is a part of Netacka 3D.
#
# Copyright 2010
# Leszek Bartkowski, Mikołaj Dądela, Paweł Marczewski, Jan Szejko
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


import sys
from os import listdir, makedirs, remove
from os.path import join, isdir, isfile
from shutil import copy

locations = dict(png="drawable",
                 jpg="drawable",
                 mesh_bin="raw")

def main():
    if len(sys.argv) != 3:
        print("Usage: python sync_assets.py in-path out-path")
        print("This script copies all files from in-path to out-path.")
        sys.exit()

    dir_in = sys.argv[1]
    dir_out = sys.argv[2]

    for f in listdir(dir_in):
        try:
            ext = f.split(".")[-1]
            loc = join(dir_out, locations[ext])
            if not isdir(loc):
                makedirs(loc)
            #print("copying: {0} -> {1}".format(f, loc))
            copy(join(dir_in, f), loc)
        except KeyError:
            print("no location specified for "+f)

if __name__ == "__main__":
    main()


# set PATH=%PATH%;C:\Program Files\Python26
