/*
 * This file is a part of Netacka 3D.
 *
 * Copyright 2010
 * Leszek Bartkowski, Mikołaj Dądela, Paweł Marczewski, Jan Szejko
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package netacka3d.test.pc;

import netacka3d.data.PlayerColor;
import netacka3d.data.MatchSettings;
import netacka3d.logic.ClientController;
import netacka3d.logic.ServerController;
import netacka3d.misc.pc.Init;
import netacka3d.ui.pc.GameWindow;

public class Main {
    
    public static void main(String[] args) throws InterruptedException {
        
        Init.init();
        
        ServerController sCon = new ServerController();
        //ClientController cCon = new ClientController();
        //new GameWindow(sCon).setVisible(true);
        //new GameWindow(cCon).setVisible(true);
        
        sCon.startGame("serwerek", new MatchSettings() {{stepRate=10.0f;}}, 4567);
        
        //Thread.sleep(1000);        
        
        //cCon.connect("klient", Color.BLUE, "127.0.0.1", 4567, 4567);
    }
    
}
